"use strict";

var _safeExtend = require("safe-extend");

var _safeExtend2 = _interopRequireDefault(_safeExtend);

var _replace = require("./replace");

var _replace2 = _interopRequireDefault(_replace);

var _query = require("./query");

var _query2 = _interopRequireDefault(_query);

var _transValue = require("./util/transValue");

var _transValue2 = _interopRequireDefault(_transValue);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

module.exports = function change(attrs, value, data, settings) {
    settings = (0, _safeExtend2.default)(true, { all: true }, settings);
    var cloneData = _safeExtend2.default.clone(data);
    settings.complete = true;
    var target = (0, _query2.default)(attrs, cloneData, settings);
    function setValue(target) {
        target.value = (0, _safeExtend2.default)(true, target.value, (0, _transValue2.default)(target, value));
        cloneData = (0, _replace2.default)(target.location, target.value, cloneData, settings);
    }
    if (settings.all) {
        target.forEach(function (item, index) {
            setValue(item);
        });
    } else {
        setValue(target);
    }
    return cloneData;
};