"use strict";

var _safeExtend = require("safe-extend");

var _safeExtend2 = _interopRequireDefault(_safeExtend);

var _replace = require("./replace");

var _replace2 = _interopRequireDefault(_replace);

var _query = require("./query");

var _query2 = _interopRequireDefault(_query);

var _create = require("./create");

var _create2 = _interopRequireDefault(_create);

var _createArray = require("./util/createArray");

var _createArray2 = _interopRequireDefault(_createArray);

var _parseQueryString = require("./util/parseQueryString");

var _parseQueryString2 = _interopRequireDefault(_parseQueryString);

var _deleteArray = require("./util/deleteArray");

var _deleteArray2 = _interopRequireDefault(_deleteArray);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var dc = require('delay-console');
module.exports = function (attrs, data, settings) {
    var defaultSettings = {
        separator: '.',
        all: true
    };
    settings = (0, _safeExtend2.default)(true, {}, defaultSettings, settings);
    settings.complete = true;
    var queryResultArray = (0, _query2.default)(attrs, data, settings);
    var output = _safeExtend2.default.clone(data);
    /*必须倒着删除，否则第一次删除后的数组位置会改变，第二次删除时位置就不准确了*/
    if (!Array.isArray(queryResultArray)) {
        queryResultArray = [queryResultArray];
    }
    queryResultArray.reverse().forEach(function (item, resultIndex) {
        var lastKey = (0, _parseQueryString2.default)(item.location.pop());
        var parentLocation = item.location;
        var target = output;
        parentLocation.forEach(function (key, index) {
            target = target[key];
        });
        /* 这段代码需要优化 */
        if (lastKey.arrayIndex) {
            var targetArray = target[lastKey.attr];
            var lastArrayIndex = lastKey.arrayIndex.pop();
            var parentArrayIndex = lastKey.arrayIndex;
            parentArrayIndex.forEach(function (index) {
                targetArray = targetArray[index];
            });
            var deletedArray = (0, _deleteArray2.default)(targetArray, lastArrayIndex);
            if (parentArrayIndex.length === 0) {
                target[lastKey.attr] = deletedArray;
            } else {
                var lastDeepArrayIndex = parentArrayIndex.pop();
                var parentDeepArrayIndex = parentArrayIndex;
                if (parentDeepArrayIndex.length === 0) {
                    target[lastKey.attr][lastDeepArrayIndex] = deletedArray;
                } else {
                    var parentDeepArray = target[lastKey.attr];
                    parentDeepArrayIndex.forEach(function (index) {
                        parentDeepArray = parentDeepArray[index];
                    });
                    parentDeepArray[lastDeepArrayIndex] = deletedArray;
                }
            }
        } else {
            delete target[lastKey.attr];
        }
    });
    return output;
};