"use strict";

var _safeExtend = require("safe-extend");

var _safeExtend2 = _interopRequireDefault(_safeExtend);

var _query = require("./query");

var _query2 = _interopRequireDefault(_query);

var _create = require("./create");

var _create2 = _interopRequireDefault(_create);

var _queryStringToArray = require("./util/queryStringToArray");

var _queryStringToArray2 = _interopRequireDefault(_queryStringToArray);

var _transValue = require("./util/transValue");

var _transValue2 = _interopRequireDefault(_transValue);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

module.exports = function replace(attrs, value, data, settings) {
    settings = (0, _safeExtend2.default)(true, { all: true }, settings);
    settings.complete = true;
    var cloneData = _safeExtend2.default.clone(data);
    var queryResult = (0, _query2.default)(attrs, cloneData, settings);
    function setValue(target) {
        cloneData = (0, _safeExtend2.default)(true, cloneData, (0, _create2.default)(target.location, ''));
        cloneData = (0, _safeExtend2.default)(true, cloneData, (0, _create2.default)(target.location, (0, _transValue2.default)(target, value)));
    }
    if (settings.all) {
        queryResult.forEach(function (item) {
            setValue(item);
        });
    } else {
        setValue(queryResult);
    }
    return cloneData;
};