'use strict';

/**
 * Parse query string
 * @param {string} queryString
 * @example
 * parseQueryString('user[1][4]')
 * // {arrayIndex: ["4", "1"], attr: "user"}
 */
module.exports = function parseQueryString(queryString) {
    var matchData = queryString.match(/(.*?)(\[.*)/);
    var attr = queryString;
    var arrayIndex = void 0;
    if (matchData) {
        attr = matchData[1];
        arrayIndex = matchData[2];
        arrayIndex = arrayIndex.replace(/(^\[|\]$)/g, '').split('][');
        arrayIndex = arrayIndex.map(function (item) {
            // item 可能是 "{id:'abcasfasf'}"
            return isNaN(parseInt(item)) ? item : parseInt(item);
        });
    }
    return {
        attr: attr,
        arrayIndex: arrayIndex
    };
};